﻿Public Class FormPrincipal
    Private Sub btExibir_Click(sender As Object, e As EventArgs) Handles btExibir.Click
        Dim ds = CriarDataSet()
        FormRelatorio.ShowReport("Relatorio.rdlc", False, New Dictionary(Of String, Object)() From {
            {"DataSetRelatorio", ds.Item}
        })
    End Sub

    Private Function CriarDataSet() As DataSetRelatorio
        Dim Ds = New DataSetRelatorio()

        For C As Integer = 1 To 200
            Ds.Item.AddItemRow(C, String.Format("Item {0}", C))
        Next

        Return Ds
    End Function

    Private Sub btImprimir_Click(sender As Object, e As EventArgs) Handles btImprimir.Click
        Using ds = CriarDataSet()
            Using Relatorio = New Microsoft.Reporting.WinForms.LocalReport()
                Relatorio.ReportPath = "Relatorio.rdlc"
                Relatorio.DataSources.Add(New Microsoft.Reporting.WinForms.ReportDataSource("DataSetRelatorio", DirectCast(ds.Item, DataTable)))

                'Exportar(Relatorio)
                'Imprimir(Relatorio)

                Using Rpd = New PrintReportSample.ReportPrintDocument(Relatorio)
                    Rpd.Print()
                End Using
            End Using
        End Using
    End Sub

    Private Sub Exportar(Relatorio As Microsoft.Reporting.WinForms.LocalReport)
        Dim Warnings As Microsoft.Reporting.WinForms.Warning()
        LimparStreams()
        Relatorio.Render("image", CriarDeviceInfo(Relatorio), AddressOf CreateStreamCallback, Warnings)
    End Sub

    Private Sub Imprimir(Relatorio As Microsoft.Reporting.WinForms.LocalReport)
        Using Pd = New System.Drawing.Printing.PrintDocument()
            Pd.PrinterSettings.PrinterName = "PrimoPDF"
            Dim PageSettings = New System.Drawing.Printing.PageSettings()
            Dim PageSettingsRelatorio = Relatorio.GetDefaultPageSettings()
            PageSettings.PaperSize = PageSettingsRelatorio.PaperSize
            PageSettings.Margins = PageSettingsRelatorio.Margins
            Pd.DefaultPageSettings = PageSettings

            AddHandler Pd.PrintPage, AddressOf Pd_PrintPage
            StreamAtual = 0
            Pd.Print()
        End Using
    End Sub

    Private StreamAtual As Integer
    Private Sub Pd_PrintPage(sender As Object, e As System.Drawing.Printing.PrintPageEventArgs)
        Dim Stream = Streams(StreamAtual)
        Stream.Seek(0, System.IO.SeekOrigin.Begin)

        Using metadata = New System.Drawing.Imaging.Metafile(Stream)
            e.Graphics.DrawImage(metadata, e.PageBounds)
        End Using

        StreamAtual += 1
        e.HasMorePages = StreamAtual < Streams.Count
    End Sub

    Private Streams As New List(Of System.IO.Stream)()
    Public Function CreateStreamCallback(Name As String, Extension As String, Encoding As System.Text.Encoding, MimeType As String, WillSeek As Boolean) As System.IO.Stream
        Dim Stream = New System.IO.MemoryStream()
        Streams.Add(Stream)
        Return Stream
    End Function

    Private Function CriarDeviceInfo(Relatorio As Microsoft.Reporting.WinForms.LocalReport) As String
        Dim PageSettings = Relatorio.GetDefaultPageSettings()
        Return String.Format(
            System.Globalization.CultureInfo.InvariantCulture,
            "<DeviceInfo><OutputFormat>EMF</OutputFormat><PageWidth>{0}in</PageWidth><PageHeight>{1}in</PageHeight><MarginTop>{2}in</MarginTop><MarginLeft>{3}in</MarginLeft><MarginRight>{4}in</MarginRight><MarginBottom>{5}in</MarginBottom></DeviceInfo>",
            PageSettings.PaperSize.Width / 100D, PageSettings.PaperSize.Height / 100D, PageSettings.Margins.Top / 100D, PageSettings.Margins.Left / 100D,
            PageSettings.Margins.Right / 100D, PageSettings.Margins.Bottom / 100D)
    End Function

    Private Sub LimparStreams()
        For Each Stream In Streams
            Stream.Dispose()
        Next
        Streams.Clear()
    End Sub
End Class
