﻿Public Class FormRelatorio
    Private Sub New(Path As String, IsEmbeddedResource As Boolean, DataSources As Dictionary(Of String, Object), Optional ReportParameters As Dictionary(Of String, Object) = Nothing)
        InitializeComponent()

        ' path + isEmbeddedResource.
        If IsEmbeddedResource Then
            Me.ReportViewer.LocalReport.ReportEmbeddedResource = Path
        Else
            Me.ReportViewer.LocalReport.ReportPath = Path
        End If

        ' dataSources.
        For Each DataSource In DataSources
            Dim ReportDataSource = New Microsoft.Reporting.WinForms.ReportDataSource(DataSource.Key, DataSource.Value)
            Me.ReportViewer.LocalReport.DataSources.Add(ReportDataSource)
        Next

        ' reportParameters.
        If ReportParameters IsNot Nothing Then
            Dim ReportParameterCollection = New List(Of Microsoft.Reporting.WinForms.ReportParameter)()

            For Each Parameter In ReportParameters
                Dim ReportParameter = New Microsoft.Reporting.WinForms.ReportParameter(Parameter.Key, Parameter.Value.ToString())
                ReportParameterCollection.Add(ReportParameter)
            Next

            Me.ReportViewer.LocalReport.SetParameters(ReportParameterCollection)
        End If
    End Sub

    Private Sub FormRelatorio_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Me.ReportViewer.RefreshReport()
    End Sub

    Public Shared Sub ShowReport(Path As String, IsEmbeddedResource As Boolean, DataSources As Dictionary(Of String, Object), Optional ReportParameters As Dictionary(Of String, Object) = Nothing)
        Dim FormRelatorio = New FormRelatorio(Path, IsEmbeddedResource, DataSources, ReportParameters)
        FormRelatorio.Show()
    End Sub
End Class